# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`g10k`](#g10k): Manages installing and configuring g10k

## Classes

### g10k

Manages installing and configuring g10k

#### Parameters

The following parameters are available in the `g10k` class.

##### `source_name`

Data type: `String`

The primary source's name.

##### `source_remote`

Data type: `String`

The primary source's remote url.

##### `source_basedir`

Data type: `String`

The base directory to use for installing components.

##### `version`

Data type: `String`

The version of g10k to install.
Default: '0.4.7'

Default value: '0.5.6'

##### `user`

Data type: `String`

The user to execute the g10k command.
Default: 'root'

Default value: 'root'

##### `cache_dir`

Data type: `String`

The path to the cache directory.
Default: '/var/cache/g10k'

Default value: '/var/cache/g10k'

##### `maxworker`

Data type: `Integer`

The number of Goroutines allowed to run in parallel for Git and Forge
module resolving

Default value: 50

##### `maxextractworker`

Data type: `Integer`

The number of Goroutines allowed to run in parallel for local Git
and Forge module extracting processes (git clone, untar and gunzip)

Default value: 20

##### `is_quiet`

Data type: `Boolean`

If true, prints no output.

Default value: `false`

##### `use_cache_fallback`

Data type: `Boolean`

If g10k is unable to connect to remote source, the local cache is used.

Default value: `false`

##### `additional_settings`

Data type: `Optional[Hash[String, String]]`

A hash of additional g10k.yaml settings that can be configured for a source.

Default value: `undef`

##### `purge_levels`

Data type: `Optional[Array[String]]`

Setting controls how aggressively g10k will purge unmanaged content during a deployment.
The valid string options for the list are 'deployment', 'environment', and 'puppetfile'.
@see https://github.com/puppetlabs/r10k/blob/master/doc/dynamic-environments/configuration.mkd#purge_levels

Default value: `undef`

##### `purge_whitelist`

Data type: `Optional[Array[String]]`

Exempts the specified filename patters from being purged.
@see https://github.com/puppetlabs/r10k/blob/master/doc/dynamic-environments/configuration.mkd#purge_whitelist

Default value: `undef`

##### `deployment_purge_whitelist`

Data type: `Optional[Array[String]]`

As an additional setting, you can also whitelist Puppet environments.

Default value: `undef`

##### `proxy_server`

Data type: `Optional[String]`

Web proxy for downloading g10k.

Default value: `undef`

##### `postrun`

Data type: `Optional[Array[String]]`

Array of strings to be set as the postrun command.
The following 3 variables are available to use as arguments.

Default value: `undef`

##### `use_generate_types`

Data type: `Boolean`

Installs a postrun script that calls 'puppet generate types --environment $env' for every environment that was updated.
Overwrites and replaces the postrun parameter.

Default value: `false`

##### `manage_git_package`

Data type: `Boolean`

If this class should manage the git package.

Default value: `true`

